import type { FC } from 'react';
import type { ComponentWithConditionPropsWithFunctionChildren } from './types';
/** A shorthand for
 *
 * ```jsx
 * <If condition={...}>
 *     <Else>
 *         { ... }
 *     </Else>
 * </If>
 * ```
 *
 * The same rules apply to the child elements as with using the `<Else />` block.
 *
 * @param __namedParameters The props to pass down to the `<IF />` component, see {@link ComponentWithConditionProps}
 */
export declare const Unless: FC<ComponentWithConditionPropsWithFunctionChildren>;
//# sourceMappingURL=Unless.d.ts.map